;    PIC16F628A (  32768 .)
; ==========================================================
	list	p=16f628a	;  
	include	<p16F628a.inc>;  
; ==============

	__CONFIG _CP_OFF & _WDT_ON & _PWRTE_ON & _LP_OSC & _LVP_OFF & _BODEN_OFF & _MCLRE_OFF
;===============================================
;   ,   
;===============================================
	CBLOCK	H'20'
	Temp						;  .
	Reg_1						;  
	Reg_2						; . 
	Step						;    	
	Watt						; 
	endc
;===============================================
;		PORT A
;===============================================
	W20			equ	0			; 
	W40			equ	1			; 
	W60			equ	2			; " ".
	W80			equ	3
	W100		equ	4
;===============================================
;		PORT B
;===============================================
;								  
	Step_D		equ	0			;	(D)
	Step_C		equ	1			;	()			
	Step_B		equ	2			;	(B)			
	Step_A		equ	3			;	(A)
	Step_E1		equ	4			;  
	Step_E2		equ	5			;  
;					6
	Power		equ	7			;  

	Set_W		equ	PORTA
	OUT			equ	PORTB

	org	0
	goto	START

;===============================================
;		 
;===============================================
Set_Watt
	btfss		Set_W, W20
	retlw		B'11000000'		;20%
	btfss		Set_W, W40
	retlw		B'11100000'		;40%
	btfss		Set_W, W60
	retlw		B'11111000'		;60%
	btfss		Set_W, W80
	retlw		B'11111100'		;80%
	btfss		Set_W, W100
	retlw		B'11111111'		;100%
	retlw		B'00000000'		;   
								;  .
;===============================================
;		 2,67 .	
;===============================================
Pause
  	movlw       .169
  	movwf       Reg_1
	movlw       .29
	movwf       Reg_2
wr_2 
	decfsz      Reg_1,f
    goto        wr_2
    clrwdt
    decfsz      Reg_2,f
    goto        wr_2
	return
;===============================================
;		    .	
;===============================================
Table
	addwf		PCL,f
	retlw		b'00110101'
	retlw		b'00100001'
	retlw		b'00111001'
	retlw		b'00011000'
	retlw		b'00111010'
	retlw		b'00100010'
	retlw		b'00110110'
	retlw		b'00010100'
;===============================================
START
;===============================================
	movlw		H'07'			;
	movwf		CMCON			;
	bsf			STATUS,RP0		;   
	movlw		B'00000000'		; RB0-RB7  ,	
	movwf		TRISB			;
	movlw		B'00011111'		; RA0-RA4  ,	
	movwf		TRISA			;
	bcf			OPTION_REG,T0CS	;   . 
	bcf			STATUS,RP0		;  
	bcf			INTCON,T0IE		;  
	bcf			INTCON,GIE		; .

	bcf			OUT,Power
	movlw		.8
	movwf		Step
	call		Set_Watt		; 
	movwf		Watt
Cirk
	call		Pause
	call		Pause
;===============================================
;		 /  
; 		 : 2,7 . * 8  = 21,6 .	
;===============================================
ON_SW
	bcf			STATUS,C		; 7   
	btfsc		Watt,7			;  
	bsf			STATUS,C
	rlf			Watt,f			;...	
	btfsc		STATUS,C		; ?
	goto		ON_SW_1			;,  
	bcf			OUT,Power		;,   
	goto		Rueck			;
ON_SW_1
	bsf			OUT,Power		;...
;===============================================
;		  .	
;===============================================
Rueck
	movfw		OUT				;
	andlw		b'10000000'		; 
	movwf		Temp			; .
	decf		Step,f			; 
	movf		Step,w			; .
	call		Table			;,   
	iorwf		Temp,w			;
	movwf		OUT				; .
	movf		Step,w			;
	btfss		STATUS,Z		; ?
	goto		Fertr			;,   .
	movlw		08				; ,
	movwf		Step			; , 
	call		Set_Watt		;  .
	movwf		Watt
Fertr
	goto		Cirk			;...	

	end							;!!! ...
	
